=== debian/changelog ===
libcifpp (7.0.7-3) unstable; urgency=medium

  * Closes: #1085237

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 29 Oct 2024 08:00:15 +0100

libcifpp (7.0.7-2) unstable; urgency=medium

  * Upload to unstable

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 29 Oct 2024 07:59:53 +0100

libcifpp (7.0.7-1) unstable; urgency=medium

  * New upstream version 
  * Standards-Version: 4.6.0 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Refer to common license file for CC0-1.0.
  * Correct URLs for downloading data. Closes: #1063191
  * Added Swedish translation. Closes: #1068860

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 14 Oct 2024 08:51:23 +0200
