## libcifpp 7.0.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 # set the project name
 project(
 	libcifpp
-	VERSION 7.0.7
+	VERSION 7.0.9
 	LANGUAGES CXX)
 
 list(PREPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
@@ -41,6 +41,11 @@
 include(GenerateExportHeader)
 include(CTest)
 include(FetchContent)
+
+# FindBoost, take care of it now.
+if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.30)
+	cmake_policy(SET CMP0167 NEW)
+endif()
 
 # When building with ninja-multiconfig, build both debug and release by default
 if(CMAKE_GENERATOR STREQUAL "Ninja Multi-Config")
@@ -375,5 +380,3 @@
 	target_link_options(cifpp PRIVATE -undefined dynamic_lookup)
 endif(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
 
-if(CIFPP_DOWNLOAD_CCD)
-	# download the components.cif file from CCD
