=== debian/changelog ===
libcifpp (7.0.9-1) unstable; urgency=medium

  * Revert "New upstream version 7.0.7"
  * New upstream version 7.0.9

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 28 Jan 2025 16:07:49 +0100
