=== debian/control ===
Source: libcifpp
Priority: optional
Section: libs
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Maarten L. Hekkelman <maarten@hekkelman.com>,
 Andreas Tille <tille@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libboost-dev,
 libboost-regex-dev,
 libeigen3-dev,
 zlib1g-dev,
 po-debconf,
 catch2,
 cmake,
 doxygen,
 python3-exhale,
 python3-sphinx-rtd-theme,
 python3-myst-parser
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/libcifpp
Vcs-Git: https://salsa.debian.org/med-team/libcifpp.git
Homepage: https://github.com/PDB-REDO/libcifpp
Rules-Requires-Root: no

Package: libcifpp-dev
Section: libdevel
Architecture: any
Depends:
 libcifpp7 (= ${binary:Version}),
 libboost-regex-dev,
 zlib1g-dev,
 ${misc:Depends},
Suggests: libcifpp-doc, mrc
Multi-Arch: same
Description: Documentation for libcifpp
 Libcifpp is a C++ library used to create and manipulate
 mmCIF and PDB files containing macro molecular structure information.
 .
 This specific package contains all files needed to develop new
 software using libcifpp.

Package: libcifpp-doc
Section: doc
Architecture: all
Depends:
 libboost-regex-dev,
 zlib1g-dev,
 ${misc:Depends},
Description: Development files for libcifpp
 Libcifpp is a C++ library used to create and manipulate
 mmCIF and PDB files containing macro molecular structure information.
 .
 This specific package contains the documentation you can use to develop new
 software using libcifpp.

Package: libcifpp7
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libcifpp-data
Multi-Arch: same
Description: Library files for libcifpp
 Libcifpp is a C++ library used to create and manipulate
 mmCIF and PDB files containing macro molecular structure information.
 .
 This package contains the library file only.

Package: libcifpp-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Breaks:
 libcifpp5.2 (<< 5.0.0-1)
Replaces:
 libcifpp5.2 (<< 5.0.0-1)
Description: Data files for libcifpp
 Libcifpp is a C++ library used to create and manipulate
 mmCIF and PDB files containing macro molecular structure information.
 .
 This package contains the architecture independent data for the library.
