=== debian/changelog ===
libcifpp (9.0.1-1) experimental; urgency=medium

  * Fix SONAME/package name mismatch

  [ Carles Pina i Estany ]
  * Added po-debconf Catalan translation

  [ Maarten L. Hekkelman ]
  * New upstream version 9.0.1

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 09 Sep 2025 11:09:20 +0200
