=== debian/control ===
--- 
+++ 
@@ -7,8 +7,7 @@
  Andreas Tille <tille@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
- libboost-dev,
- libboost-regex-dev,
+ libpcre2-dev,
  libeigen3-dev,
  zlib1g-dev,
  po-debconf,
@@ -18,7 +17,7 @@
  python3-exhale,
  python3-sphinx-rtd-theme,
  python3-myst-parser
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/libcifpp
 Vcs-Git: https://salsa.debian.org/med-team/libcifpp.git
 Homepage: https://github.com/PDB-REDO/libcifpp
@@ -28,7 +27,7 @@
 Section: libdevel
 Architecture: any
 Depends:
- libcifpp7 (= ${binary:Version}),
+ libcifpp9 (= ${binary:Version}),
  libboost-regex-dev,
  zlib1g-dev,
  ${misc:Depends},
@@ -55,7 +54,7 @@
  This specific package contains the documentation you can use to develop new
  software using libcifpp.
 
-Package: libcifpp7
+Package: libcifpp9
 Architecture: any
 Depends:
  ${misc:Depends},
