=== debian/tests/control ===
Tests: run-build-test
Depends:
 build-essential,
 libcifpp-dev,
 zlib1g-dev,
 cmake
Restrictions: allow-stderr
