=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libcifpp-$1\.tar\.gz/ \
  https://github.com/PDB-REDO/libcifpp/tags .*/v?(\d\S+)\.tar\.gz
