## libcifpp 9.0.5

=== debian/changelog ===
libcifpp (9.0.5-2) unstable; urgency=medium

  * Added debian/clean, Closes: #1048817

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 23 Nov 2025 13:32:02 +0100

libcifpp (9.0.5-1) unstable; urgency=medium

  * New upstream version 9.0.5

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 20 Nov 2025 09:25:54 +0100

libcifpp (9.0.1-2) unstable; urgency=medium

  * Transition, Closes: #1120992

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 19 Nov 2025 11:25:34 +0100
